
%**************************************************************************
% Programm prediction_based_filter_design_demo_main
%
% Author:              Gerhard Schmidt, CAU Digital Signal Processing and
%                      System Theory
% Date of generation:  2009
% Project:             prediction based filter design
%
% 
% Input: 
%
% Output:               ---
%
%**************************************************************************


%******************************************************************
% Set path to subdirectories
%******************************************************************
 
addpath([pwd,'/subfunctions']);

%******************************************************************
% Main data_struct
%******************************************************************

dim.main_fig.orig_x                        =   12;
dim.main_fig.orig_y                        =   45;
dim.main_fig.width                         = 1000;
dim.main_fig.height                        =  670;
dim.main_fig.space_lr                      =   30; 
dim.main_fig.space_tb                      =   30;
dim.main_fig.af_logo.width                 =  342;
dim.main_fig.af_logo.height                =   48;
dim.main_fig.low_frame.height              =   48;
dim.main_fig.low_frame.button.width        =  140;
dim.main_fig.low_frame.button.height       =   32;
dim.main_fig.low_frame.button.delta_w      =   30;
dim.main_fig.low_frame.checkbox.width      =  100;
dim.main_fig.left_frame.width.small        =  200;
dim.main_fig.left_frame.width.large        =  700;
dim.main_fig.left_frame.space_lr           =   10;
dim.main_fig.left_frame.space_lr_sm        =   10;
dim.main_fig.left_frame.space_tb           =   10;
dim.main_fig.left_frame.space_tb_sm        =    2;
dim.main_fig.left_frame.button.height      =   25;
dim.main_fig.left_frame.button.text_offset =    4;
dim.main_fig.axes.space_left               =   60;
dim.main_fig.axes.space_bottom             =   30;
dim.main_fig.axes.space_delta              =   16;

fonts.normal.size      =  9;
fonts.upper_frame.size = 12;
fonts.small.size       =  9;

main_data.N_FFT             = 512;
main_data.des_freq_res_log  = zeros(main_data.N_FFT/2+1,1);
main_data.des_freq_res_lin  = ones(main_data.N_FFT/2+1,1);
main_data.des_freq_supp_p_x = [];
main_data.des_freq_supp_p_y = [];
main_data.N_FIR             = 16;
main_data.N_IIR             = 16;

%Zum Testen
main_data.des_freq_res_lin(40:70)    = 10;
main_data.des_freq_res_lin(160:200) = 0.2;
main_data.des_freq_res_lin = filtfilt(1-0.7, [1 -0.7],main_data.des_freq_res_lin);





main_data.predictor.length          =   12;
main_data.predictor.frameshift      =   64;
main_data.predictor.n_ana           =  512;

main_data.predictor.h_ana           = hanning(main_data.predictor.n_ana);
main_data.predictor.n_fft           = 1024;
main_data.predictor.k_frame         = ceil(main_data.predictor.n_ana / (2*main_data.predictor.frameshift));
main_data.predictor.k_dir           =    1;
main_data.predictor.h               = [1; zeros(main_data.predictor.length,1)];
main_data.predictor.gain            =    1;
main_data.predictor.x_ana           = zeros(main_data.predictor.n_ana,1);
main_data.predictor.x_p             = zeros(main_data.predictor.length+1,1);
main_data.predictor.error_vec       = zeros(main_data.predictor.frameshift,1);

main_data.axes_top.plot_method            = 'imp_res';
main_data.axes_top.plot_handle_1          = 0;
main_data.axes_top.plot_handle_2          = 0;
main_data.axes_top.index                  = 0;
main_data.axes_top.plot_method_changed    = 0;
main_data.axes_bottom.plot_method         = 't_ana';
main_data.axes_bottom.plot_handle_1       = 0;
main_data.axes_bottom.plot_handle_2       = 0;
main_data.axes_bottom.index               = 0;
main_data.axes_bottom.plot_method_changed = 0;

main_data.sim_active = 0;
main_data.auto_mode  = 1;

%******************************************************************
% User interface
%******************************************************************

load prediction_based_filter_design_demo_main;

a = figure('Units','pixels', ...
           'Color',[0.85 0.85 0.85], ...
           'Colormap',mat0, ...
           'Name','Adaptive Filters - Demo Prediction Based Filter Design', ...         
	       'NumberTitle','off', ...
           'PointerShapeCData',mat1, ...
	       'Position',[dim.main_fig.orig_x dim.main_fig.orig_y dim.main_fig.width dim.main_fig.height], ...
           'UserData',main_data, ...
           'Tag','demo_pbfd_main_fig');                  
      
%******************************************************************
% Title frame
%******************************************************************       
          
b = axes('Parent',a, ...
         'Units','pixels', ...
	     'Box','on', ...
	     'CameraUpVector',[0 1 0], ...
	     'Color',[1 1 1], ...
         'ColorOrder',mat2, ... 
         'CreateFcn','image(logo_adaptive_filters); axis tight; set(gca,''XTick'',[],''YTick'',[]);', ...
	     'Position',[dim.main_fig.space_lr dim.main_fig.height-dim.main_fig.space_tb-dim.main_fig.af_logo.height dim.main_fig.af_logo.width dim.main_fig.af_logo.height], ...
	     'Tag','demo_predictor_axes_logo');

b = uicontrol('Parent',a, ...                       
	          'Units','pixels', ...                   
	          'BackgroundColor',[0.9 0.9 0.9], ...   
              'Position',[dim.main_fig.af_logo.width+(2*dim.main_fig.space_lr) dim.main_fig.height-dim.main_fig.space_tb-dim.main_fig.af_logo.height dim.main_fig.width-(3*dim.main_fig.space_lr)-dim.main_fig.af_logo.width dim.main_fig.af_logo.height], ...
	          'Style','frame', ...
              'Tag','demo_predictor_uppper_fraime'); 
                                                      
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.9 0.9 0.9], ...   
	          'HorizontalAlignment','center', ...
              'FontWeight','bold', ...
              'FontSize',fonts.upper_frame.size, ...
	          'Position',[dim.main_fig.af_logo.width+(2*dim.main_fig.space_lr)+5 dim.main_fig.height-dim.main_fig.space_tb-dim.main_fig.af_logo.height+12 dim.main_fig.width-(3*dim.main_fig.space_lr)-dim.main_fig.af_logo.width-10 20], ...
	          'String','Demo - Prediction Based Filter Design', ...
	          'Style','text');  
                   
%******************************************************************
% Left frame (visible)
%******************************************************************    
                        
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
	          'BackgroundColor',[0.9 0.9 0.9], ...   
              'Position',[dim.main_fig.space_lr (2*dim.main_fig.space_tb)+dim.main_fig.af_logo.height dim.main_fig.left_frame.width.small dim.main_fig.height-(4*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-dim.main_fig.low_frame.height ], ...
	          'Style','frame', ...
              'Tag','demo_predictor_main_left_frame');           
                                                                                            
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
	          'BackgroundColor',[0.95 0.95 0.95], ...   
              'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(9*dim.main_fig.left_frame.space_tb)-(2*dim.main_fig.left_frame.space_tb_sm)-(9*dim.main_fig.left_frame.button.height) dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr) (3*dim.main_fig.left_frame.button.height)+(2*dim.main_fig.left_frame.space_tb)], ...
	          'Style','frame', ...
              'Tag','demo_predictor_main_left_frame_control_para');   
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.normal.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(7*dim.main_fig.left_frame.space_tb)-(7*dim.main_fig.left_frame.button.height)-(5*dim.main_fig.left_frame.space_tb_sm) dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','Filter parameters:', ...
	          'Tag','demo_predictor_main_left_frame_text_control_parameters', ...
              'Style','text');            

b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(7*dim.main_fig.left_frame.space_tb)-(8*dim.main_fig.left_frame.button.height)-(5*dim.main_fig.left_frame.space_tb_sm) round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','FIR Order:', ...
	          'Tag','demo_predictor_main_left_frame_text_para_order_FIR_left', ...
              'Style','text');    
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[1 1 1], ...   
	          'HorizontalAlignment','right', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+round(dim.main_fig.left_frame.width.small/2)  dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(7*dim.main_fig.left_frame.space_tb)-(8*dim.main_fig.left_frame.button.height)-(5*dim.main_fig.left_frame.space_tb_sm) round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String',num2str(main_data.N_FIR), ...
              'Callback','main_data = get(gcf,''UserData''); main_data.N_FIR = str2num(get(gco,''String'')); set(gcf,''UserData'',main_data); pbfd_design_filters;', ...
	          'TooltipString','Sets the order of the predictor error filters',...
              'Tag','demo_predictor_main_left_frame_edit_para_order_FIR_right', ...
              'Style','edit');           
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(7*dim.main_fig.left_frame.space_tb)-(9*dim.main_fig.left_frame.button.height)-(5*dim.main_fig.left_frame.space_tb_sm) round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','IIR Order:', ...
	          'Tag','demo_predictor_main_left_frame_text_para_order_IIR_left', ...
              'Style','text');    
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[1 1 1], ...   
	          'HorizontalAlignment','right', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+round(dim.main_fig.left_frame.width.small/2)  dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(7*dim.main_fig.left_frame.space_tb)-(9*dim.main_fig.left_frame.button.height)-(5*dim.main_fig.left_frame.space_tb_sm) round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String',num2str(main_data.N_IIR), ...
              'Callback','main_data = get(gcf,''UserData''); main_data.N_IIR = str2num(get(gco,''String'')); set(gcf,''UserData'',main_data); pbfd_design_filters;', ...
	          'TooltipString','Sets the order of the predictor error filters',...
              'Tag','demo_predictor_main_left_frame_edit_para_order_IIR_right', ...
              'Style','edit');             
                
%******************************************************************
% Left frame (hidden)
%******************************************************************              
 
b = axes('Parent',a, ...
         'Units','pixels', ...
	     'Box','on', ...
         'Visible','off', ...
	     'CameraUpVector',[0 1 0], ...
	     'Color',[1 1 1], ...
         'ColorOrder',mat2, ... 
         'CreateFcn','set(gca,''XTick'',[],''YTick'',[]);', ...         
	     'Position',[2*dim.main_fig.space_lr+dim.main_fig.left_frame.width.small  (2*dim.main_fig.space_tb)+dim.main_fig.af_logo.height 1 dim.main_fig.height-(4*dim.main_fig.space_tb)-(2*dim.main_fig.af_logo.height)], ...
	     'Tag','demo_predictor_axes_hidden'); 

%******************************************************************
% Main axes (top)
%******************************************************************              
          
b = axes('Parent',a, ...
         'Units','pixels', ...
	     'Box','on', ...
	     'CameraUpVector',[0 1 0], ...
	     'Color',[1 1 1], ...
         'ColorOrder',mat2, ...     
	     'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.width.small+dim.main_fig.axes.space_left round(dim.main_fig.height/2)+dim.main_fig.axes.space_bottom+round(dim.main_fig.axes.space_delta/2)  dim.main_fig.width-(2*dim.main_fig.space_lr)-dim.main_fig.left_frame.width.small-dim.main_fig.axes.space_left dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-round(dim.main_fig.height/2)-dim.main_fig.axes.space_bottom-round(dim.main_fig.axes.space_delta/2)], ...
	     'Tag','demo_pbfd_axes_top');              
               
%******************************************************************
% Main axes (bottom)
%******************************************************************     
     
b = axes('Parent',a, ...
         'Units','pixels', ...
	     'Box','on', ...
	     'CameraUpVector',[0 1 0], ...
	     'Color',[1 1 1], ...
         'ColorOrder',mat2, ...      
	     'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.width.small+dim.main_fig.axes.space_left (2*dim.main_fig.space_tb)+dim.main_fig.low_frame.height+dim.main_fig.axes.space_bottom  dim.main_fig.width-(2*dim.main_fig.space_lr)-dim.main_fig.left_frame.width.small-dim.main_fig.axes.space_left round(dim.main_fig.height/2)-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-dim.main_fig.axes.space_bottom-round(dim.main_fig.axes.space_delta/2)], ...
	     'Tag','demo_pbfd_axes_bottom');                                       
     
%******************************************************************
% Lower frame
%******************************************************************    
                        
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
	          'BackgroundColor',[0.9 0.9 0.9], ...   
              'Position',[dim.main_fig.space_lr dim.main_fig.space_tb dim.main_fig.width-(2*dim.main_fig.space_lr) dim.main_fig.low_frame.height], ...
	          'Style','frame', ...
              'Tag','demo_predictor_lower_frame');           
          
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
              'Position',[dim.main_fig.width-dim.main_fig.left_frame.space_lr-dim.main_fig.low_frame.button.delta_w-dim.main_fig.low_frame.button.width dim.main_fig.space_tb+round((dim.main_fig.low_frame.height-dim.main_fig.low_frame.button.height)/2) dim.main_fig.low_frame.button.width dim.main_fig.low_frame.button.height], ...  
              'Callback','q_dlg = questdlg(''Do you really want to close the application?'',''Adaptive Filters - Demo Predictor'',''Yes'',''No'',''Cancel'',''Yes''); if strcmp(q_dlg,''Yes''),close(gcf);end;', ...             
	          'String','Close', ...
              'FontWeight','bold', ... 
              'TooltipString','Click here to close the application!',...
              'Tag','demo_predictor_button_close');      
          
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
              'Position',[650 dim.main_fig.space_tb+round((dim.main_fig.low_frame.height-dim.main_fig.low_frame.button.height)/2) dim.main_fig.low_frame.button.width dim.main_fig.low_frame.button.height], ...
              'Callback','pbfd_design_filters;', ...             
	          'String','Design filters', ...
              'FontWeight','bold', ... 
              'TooltipString','Click here to close the application!',...
              'Tag','demo_predictor_button_design_filters');           
 
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
              'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr dim.main_fig.space_tb+round((dim.main_fig.low_frame.height-dim.main_fig.low_frame.button.height)/2) dim.main_fig.low_frame.button.width dim.main_fig.low_frame.button.height], ...
              'Callback','pbfd_add_freq_supp_point;', ...             
	          'String','Add points', ...
              'FontWeight','bold', ... 
              'TooltipString','Click here to add a new frequency supporting point!',...
              'Tag','demo_predictor_button_add_point');    
          
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
              'Position',[210 dim.main_fig.space_tb+round((dim.main_fig.low_frame.height-dim.main_fig.low_frame.button.height)/2) dim.main_fig.low_frame.button.width dim.main_fig.low_frame.button.height], ...
              'Callback','pbfd_del_freq_supp_point;', ...             
	          'String','Delete points', ...
              'FontWeight','bold', ... 
              'TooltipString','Click here to delete a new frequency supporting point!',...
              'Tag','demo_predictor_button_del_point');                
                  
%******************************************************************
% Allow resizing of the figure
%******************************************************************          
             
ui_cons = findobj('Units','Pixels');
for n = 1:length(ui_cons)
    set(ui_cons(n),'Units','Normalized');
end;

pbfd_plot_init(1);     
pbfd_plot_init(2);     

pbfd_design_filters;
