function pbfd_add_freq_supp_point();

tag_figure = 'demo_pbfd_main_fig';
handle_fig = findobj('Tag',tag_figure);
main_data  = get(handle_fig,'UserData');
tag_axes   = 'demo_pbfd_axes_top';

PointValid = 1;

while (PointValid == 1)
    main_data  = get(handle_fig,'UserData');
    set(handle_fig,'CurrentAxes',findobj('Tag',tag_axes));
    [x, y] = ginput(1);
    if ((x < 0) || (x > 1) || (y<-30) || (y > 30))
        PointValid = 0;
    end;
    if (PointValid == 1)
        if (isempty(main_data.des_freq_supp_p_x))
            main_data.des_freq_supp_p_x = x;
            main_data.des_freq_supp_p_y = y;
            main_data.des_freq_res_log  = main_data.des_freq_res_log * 0 + y;
        else
            [main_data.des_freq_supp_p_x, i] = sort([main_data.des_freq_supp_p_x,x]);
            main_data.des_freq_supp_p_y = [main_data.des_freq_supp_p_y,y];
            main_data.des_freq_supp_p_y = main_data.des_freq_supp_p_y(i);
        end;

        f_out = (0:main_data.N_FFT/2)/(main_data.N_FFT/2);
        main_data.des_freq_res_log = interp1([0,main_data.des_freq_supp_p_x,1],[main_data.des_freq_supp_p_y(1),main_data.des_freq_supp_p_y,main_data.des_freq_supp_p_y(end)],f_out,'pchip');
        main_data.des_freq_res_lin = (10.^(main_data.des_freq_res_log/20))';


        tag_axes = 'demo_pbfd_axes_top';
        set(gcf,'CurrentAxes',findobj('Tag',tag_axes));

        cla;
        handle_1 = plot((0:main_data.N_FFT/2)/(main_data.N_FFT/2),main_data.des_freq_res_log,'b','LineWidth',2);
        hold on;
        handle_2 = plot(main_data.des_freq_supp_p_x,main_data.des_freq_supp_p_y,'bo','LineWidth',2);
        hold off;
        axis([0 1 -30 30]);
        grid on;
        xlabel('Normalized frequency / \pi');
        ylabel('dB');
        legend('Desired frequency response');
        drawnow;
        set(gca,'Tag',tag_axes);
        set(handle_fig,'UserData',main_data);
    end;
end;
pbfd_design_filters;
